DATA = {
  "Examples": [], 
  "dist": "bob.pad.voice-1.0.4-py_0", 
  "python-scripts": [], 
  "site-packages": [
    "bob.pad.voice-1.0.4-py3.6.egg-info/PKG-INFO", 
    "bob.pad.voice-1.0.4-py3.6.egg-info/SOURCES.txt", 
    "bob.pad.voice-1.0.4-py3.6.egg-info/dependency_links.txt", 
    "bob.pad.voice-1.0.4-py3.6.egg-info/entry_points.txt", 
    "bob.pad.voice-1.0.4-py3.6.egg-info/requires.txt", 
    "bob.pad.voice-1.0.4-py3.6.egg-info/top_level.txt", 
    "bob/pad/voice/__init__.py", 
    "bob/pad/voice/algorithm/__init__.py", 
    "bob/pad/voice/algorithm/dummy_algorithm.py", 
    "bob/pad/voice/algorithm/gmm_algorithm.py", 
    "bob/pad/voice/algorithm/histdistance_algorithm.py", 
    "bob/pad/voice/algorithm/logregr_algorithm.py", 
    "bob/pad/voice/algorithm/tensorflow_algorithm.py", 
    "bob/pad/voice/config/__init__.py", 
    "bob/pad/voice/config/algorithm/__init__.py", 
    "bob/pad/voice/config/algorithm/gmm_scfc.py", 
    "bob/pad/voice/config/algorithm/normlogregr_algorithm.py", 
    "bob/pad/voice/config/algorithm/pcalogregr_algorithm.py", 
    "bob/pad/voice/config/database/__init__.py", 
    "bob/pad/voice/config/database/asvspoof.py", 
    "bob/pad/voice/config/database/asvspoof2017.py", 
    "bob/pad/voice/config/database/avspoof.py", 
    "bob/pad/voice/config/database/voicepa.py", 
    "bob/pad/voice/config/extractor/__init__.py", 
    "bob/pad/voice/config/extractor/lbp_eurecom.py", 
    "bob/pad/voice/config/extractor/lbp_regular8_2hist.py", 
    "bob/pad/voice/config/extractor/ratio20.py", 
    "bob/pad/voice/config/grid/__init__.py", 
    "bob/pad/voice/config/grid/demanding.py", 
    "bob/pad/voice/config/preprocessor/__init__.py", 
    "bob/pad/voice/database/__init__.py", 
    "bob/pad/voice/database/asvspoof.py", 
    "bob/pad/voice/database/asvspoof2017.py", 
    "bob/pad/voice/database/avspoof.py", 
    "bob/pad/voice/database/database.py", 
    "bob/pad/voice/database/replay.py", 
    "bob/pad/voice/database/replaymobile.py", 
    "bob/pad/voice/database/voicepa.py", 
    "bob/pad/voice/extractor/__init__.py", 
    "bob/pad/voice/extractor/audio_tensorflow.py", 
    "bob/pad/voice/extractor/dummy_tensorflow.py", 
    "bob/pad/voice/extractor/glcms.py", 
    "bob/pad/voice/extractor/lbp_histograms.py", 
    "bob/pad/voice/extractor/lbps.py", 
    "bob/pad/voice/extractor/ratios.py", 
    "bob/pad/voice/extractor/spectrogram_extended.py", 
    "bob/pad/voice/extractor/vectors_ratios.py", 
    "bob/pad/voice/test/__init__.py", 
    "bob/pad/voice/test/data/attack_laptop_sentence01.wav", 
    "bob/pad/voice/test/data/attack_phone_sentence01.wav", 
    "bob/pad/voice/test/data/attack_ss_sentence01.wav", 
    "bob/pad/voice/test/data/genuine_laptop2_sentence01.wav", 
    "bob/pad/voice/test/data/genuine_laptop_sentence01.wav", 
    "bob/pad/voice/test/data/genuine_phone_sentence01.wav", 
    "bob/pad/voice/test/data/test_energylbp/scores-dev", 
    "bob/pad/voice/test/data/test_energylbp/scores-dev-attack", 
    "bob/pad/voice/test/data/test_energylbp/scores-dev-real", 
    "bob/pad/voice/test/data/test_energylbp/scores-eval", 
    "bob/pad/voice/test/data/test_energylbp/scores-eval-attack", 
    "bob/pad/voice/test/data/test_energylbp/scores-eval-real", 
    "bob/pad/voice/test/dummy/__init__.py", 
    "bob/pad/voice/test/dummy/database.py", 
    "bob/pad/voice/test/test_databases.py", 
    "bob/pad/voice/test/test_spoofspeech.py", 
    "bob/pad/voice/utils/__init__.py", 
    "bob/pad/voice/utils/extraction.py", 
    "bob/pad/voice/utils/scores.py"
  ]
}
## END DATA

"""
This is code that is added to noarch Python packages. See
conda_build/noarch_python.py.

"""
import os
from os.path import dirname, exists, isdir, join, normpath
import sys
import shutil


# Silence pyflakes. This variable is added when link.py is written by
# conda_build.noarch_python.
if False:
    DATA = None

THIS_DIR = dirname(__file__)
PREFIX = normpath(sys.prefix)
if sys.platform == 'win32':
    BIN_DIR = join(PREFIX, 'Scripts')
    SITE_PACKAGES = 'Lib/site-packages'
else:
    BIN_DIR = join(PREFIX, 'bin')
    SITE_PACKAGES = 'lib/python%s/site-packages' % sys.version[:3]

# the list of these files is going to be store in info/_files
FILES = []


def _link(src, dst):
    try:
        os.link(src, dst)
        # on Windows os.link raises AttributeError
    except (OSError, AttributeError):
        shutil.copy2(src, dst)


def _unlink(path):
    try:
        os.unlink(path)
    except OSError:
        pass


def pyc_f(f, version_info=sys.version_info):
    if version_info[0] == 2:
        return f + 'c'
    dn, fn = f.rsplit('/', 1)
    return '%s/__pycache__/%s.cpython-%d%d.pyc' % (
              dn, fn[:-3], version_info[0], version_info[1])


def link_files(src_root, dst_root, files):
    for f in files:
        src = join(THIS_DIR, src_root, f)
        dst = join(PREFIX, dst_root, f)
        dst_dir = dirname(dst)
        if not isdir(dst_dir):
            os.makedirs(dst_dir)
        if exists(dst):
            _unlink(dst)
        _link(src, dst)
        f = '%s/%s' % (dst_root, f)
        FILES.append(f)
        if f.endswith('.py'):
            FILES.append(pyc_f(f))


def create_script(fn):
    src = join(THIS_DIR, 'python-scripts', fn)
    dst = join(BIN_DIR, fn)
    if sys.platform == 'win32':
        shutil.copy2(src, dst + '-script.py')
        FILES.append('Scripts/%s-script.py' % fn)
        shutil.copy2(join(THIS_DIR,
                          'cli-%d.exe' % (8 * tuple.__itemsize__)),
                     dst + '.exe')
        FILES.append('Scripts/%s.exe' % fn)
    else:
        with open(src) as fi:
            data = fi.read()
        with open(dst, 'w') as fo:
            fo.write('#!%s\n' % normpath(sys.executable))
            fo.write(data)
        os.chmod(dst, 0o775)
        FILES.append('bin/%s' % fn)


def create_scripts(files):
    if not files:
        return
    if not isdir(BIN_DIR):
        os.mkdir(BIN_DIR)
    for fn in files:
        create_script(fn)


def main():
    create_scripts(DATA['python-scripts'])
    link_files('site-packages', SITE_PACKAGES, DATA['site-packages'])
    link_files('Examples', 'Examples', DATA['Examples'])

    with open(join(PREFIX, 'conda-meta',
                   '%s.files' % DATA['dist']), 'w') as fo:
        for f in FILES:
            fo.write('%s\n' % f)


if __name__ == '__main__':
    main()
